require "coveralls"
Coveralls.wear!

require "active_record"
require "database_cleaner"

ActiveRecord::Base.establish_connection(
  :adapter => "sqlite3", :database => ":memory:"
)

ActiveRecord::Migration.create_table :parents
ActiveRecord::Migration.create_table :children do |t|
  t.string :child_name
  t.references :parent
end

RSpec.configure do |config|
  config.before(:suite) do
    DatabaseCleaner.strategy = :transaction
    DatabaseCleaner.clean_with(:truncation)
  end

  config.before(:each) do
    DatabaseCleaner.start
  end

  config.after(:each) do
    DatabaseCleaner.clean
  end

  config.order = "random"
end
